
/* $Header: campol.h,v 1.14 93/01/10 22:44:09 apian Exp $ */

/*
	CAUTION: somewhere this is included without mentoining it in makefile
*/

typedef struct Campol_knot {	/* # = user selectable parameter */
	cam_para mp;		/* # camera parameter at knot */
	HUBA_matrix C;		/*   matrix to tilt camera object */
	cam_para *ip;		/*   interpolated camera parameters,index=0 first after knot */
	int frames;		/* # frames for the following spline = interpolated values +1*/
	int framenumber;	/*   frame number for this knot */
	int knotnumber;		/*   knot number for this knot */
	int nop;		/*   actual number of interpolated values */
	int mnop;		/*   maximum of nop, for malloc bookeeping only */
	HUBA_matrix MP;		/*   spatial Hermite-Point matrix from this point to next one */
	float D[3];		/*   spatial "tangent" vector at this point */
	float a;		/* # spatial spline bend factor */
	int nol;		/*   size of length array */
	float *la;		/*   spline length array with length behind the knot */
	struct Campol_knot *next, *prev; /* linked list pointers */
	} campol_knot;


	int     count_cpk();
	campol_knot     *return_active_cpk();
	campol_knot *search_cpk_by_number( int );
	cam_para *set_active_cpk_by_number( int );
	void    active_cpk_update( cam_para *);
	void    active_cpk_frame_update( int );
	campol_knot *cpk_enter( cam_para *, int, float, campol_knot *);
	campol_knot *cpk_enter_and_recalc( cam_para *, int, float, campol_knot *);
	void	cpks_split_by_number( int cpk_num, int int_num );
	void    return_C_active_cpk( HUBA_matrix );
	campol_knot *cpk_enter( cam_para *, int, float, campol_knot *);
	void    cpk_delete( campol_knot *);
	void    active_cpk_delete( );
	int	return_framenumber();
	int	return_frames();
	int	return_knotnumber();

