
/* $Header: sbinteg.h,v 1.4 93/01/08 23:29:01 apian Exp $ */


typedef struct {
    short	  dev;		/* Device number */
    char	* str;		/* Textual rep of dev - for debug if reqd*/
    short	  ret_val;	/* Set to true if it is a spaceball event */
    int	      ( * func )( );	/* Function to call when event occurs */
    int		  param;	/* Parameter to the function */
} sbx_event;

int	sbx_period();
int	sbx_t();
int	sbx_r();
int	sbx_k1();
int	sbx_k2();
int	sbx_k3();
int	sbx_k4();
int	sbx_k5();
int	sbx_k6();
int	sbx_k7();
int	sbx_k8();
int	sbx_pick();

int	 spcbal_do( Coord *, float, Coord *, float );

sbx_event	sbx_table[] = {
{
    SBPERIOD,	/* short  dev;	Device number */
    "SBPERIOD",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_period,	/* int ( * func )();Function to call when event occurs */
    0		/* int  param;Parameter to the function */
},
{
    SBTX,	/* short  dev;	Device number */
    "SBTX",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_t,	/* int ( * func )();Function to call when event occurs */
    0		/* int  param;Parameter to the function */
},
{
    SBTY,	/* short  dev;	Device number */
    "SBTY",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_t,	/* int ( * func )();Function to call when event occurs */
    1		/* int  param;Parameter to the function */
},
{
    SBTZ,	/* short  dev;	Device number */
    "SBTZ",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_t,	/* int ( * func )();Function to call when event occurs */
    2		/* int  param;Parameter to the function */
},
{
    SBRX,	/* short  dev;	Device number */
    "SBRX",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_r,	/* int ( * func )();Function to call when event occurs */
    0		/* int  param;Parameter to the function */
},
{
    SBRY,	/* short  dev;	Device number */
    "SBRY",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_r,	/* int ( * func )();Function to call when event occurs */
    1		/* int  param;Parameter to the function */
},
{
    SBRZ,	/* short  dev;	Device number */
    "SBRZ",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_r,	/* int ( * func )();Function to call when event occurs */
    2		/* int  param;Parameter to the function */
},
{
    SBBUT1,	/* short  dev;	Device number */
    "SBBUT1",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_k1,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
{
    SBBUT2,	/* short  dev;	Device number */
    "SBBUT2",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_k2,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
{
    SBBUT3,	/* short  dev;	Device number */
    "SBBUT3",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_k3,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
{
    SBBUT4,	/* short  dev;	Device number */
    "SBBUT4",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_k4,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
{
    SBBUT5,	/* short  dev;	Device number */
    "SBBUT5",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_k5,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
{
    SBBUT6,	/* short  dev;	Device number */
    "SBBUT6",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_k6,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
{
    SBBUT7,	/* short  dev;	Device number */
    "SBBUT7",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_k7,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
{
    SBBUT8,	/* short  dev;	Device number */
    "SBBUT8",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_k8,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
{
    SBPICK,	/* short  dev;	Device number */
    "SBPICK",	/* char	* str;	Textual rep of dev - for debug if reqd*/
    1,		/* short  ret_val;Set to true if it is a spaceball event */
    sbx_pick,	/* int ( * func )();Function to call when event occurs */
    0  		/* int  param;Parameter to the function */
},
};	/* sbx_table */
