/* Copyright (c) 1992,93 Fraunhofer Institut for solar Energy ISE */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#ifdef VOGL
#include <vogl.h>
#include <vodevice.h>
#else
#include <gl.h>
#include <gl/device.h>
#endif

#include "rshow.h"
#include "instances.h"
#include "gl_int.h"
#include "matrix.h"

static  float t_stepsize;
static  float nullvec[3]={0.0,0.0,0.0};
static  float sbv_t[3], sbv_r[3];
#define VECSET(v,x,y,z) ((v)[0]=x,(v)[1]=y,(v)[2]=z)

static char rcsid[]="$Header: voglkeys.c,v 1.22 93/05/04 16:42:56 apian Exp $";

extern  radi_gl_attris  attri;

extern	int verbose_flag;
extern  int sur;
extern	char *view_file;
extern	char *knots_file;


#ifdef VOGL					
int spcbal_do( Coord *, float, Coord *, float);
/*-----------------------*--------------------------------------------------------------------------*/
key_mouse_events( short devid, short val )	/* VOGL pure ascii keyboard interface */
{
	register cam_para *c;
	register float objrad;
	register float a;
	static tdir=1.0;
	static rshow_instance* old_picked;

	c= &(attri.current_cam);
	objrad= attri.world_size * 0.01 ;

	  switch( devid ) {

	    case( KEYBD ) :			/* analyze keys pressed */
	      switch( val ) {

	        case( 'r' ):				/* reset view */
		  spchome();
	        break;
		case( 'v' ):				 /* reset view to file default */
	 	  loadmatrix( attri.vf_matrix );
		  getmatrix( attri.my_matrix );
		  split_mat();
		  sur=1;
		break;
		case( 't' ):				/* set things straight */
		  sbx_k3( 0, 1, 0 );
		break;
		case( 'h' ):				/* toggle help display */
		  attri.draw_help ^= 1;
		  sur=1;
		break;

	        case( '1' ):				/* dump view files */
		  cpks_write_knots( knots_file );
		  write_view_file( view_file );
	        break;
	        case( '2' ):				/* toggle instance drawing */
		  attri.draw_instances= (attri.draw_instances+1)%3;
		  sur=1;
	        break;
	        case( '3' ):				/* toggle mesh drawing */
		  attri.draw_meshes^= 1;
		  sur=1;
	        break;
	        case( '4' ):				/* toggle segment (line) drawing */
		  attri.draw_segments^= 1;
		  sur=1;
	        break;
	        case( '5' ):				/* backfacing polygons on/off */
		  attri.backface_flag= 1-attri.backface_flag;
		  sur=1;
	        break;
	        case( '6' ):				/* toggle string display */
		  attri.draw_display ^= 1;
		  sur=1;
	        break;
						
	        case( 'q' ):					/* turn left&right */
	 	  VECSET( sbv_r, 0.0,  1.0, 0.0 );
		  spcbal_do( sbv_r, 0.01, nullvec, 0.0 );
	        break;
	        case( 'w' ):
		  VECSET( sbv_r, 0.0,  -1.0, 0.0 );
		  spcbal_do( sbv_r, 0.01, nullvec, 0.0 );
	        break;
  
	        case( 'e' ):					/* turn up&down */
		  VECSET( sbv_r, 1.0, 0.0, 0.0 );
		  spcbal_do( sbv_r, 0.01, nullvec, 0.0 );
	        break;
	        case( 'd' ):
		  VECSET( sbv_r,-1.0, 0.0, 0.0 );
		  spcbal_do( sbv_r, 0.01, nullvec, 0.0 );
	        break;
  
	        case( 'a' ):					/* tilt camera */
		  VECSET( sbv_r, 0.0, 0.0, 1.0 );
		  spcbal_do( sbv_r, 0.01, nullvec, 0.0 );
	        break;
	        case( 's' ):
		  VECSET( sbv_r, 0.0, 0.0,-1.0 );
		  spcbal_do( sbv_r, 0.01, nullvec, 0.0 );
	        break;
  
	        case( 'i' ):				/* move forward */
	  	  VECSET( sbv_t, 0.0, 0.0,+1.0 );
		  spcbal_do( nullvec, 1.0, sbv_t, 0.01 );
	        break;
	        case( 'm' ):				/* move backward */
	  	  VECSET( sbv_t, 0.0, 0.0,-1.0 );
		  spcbal_do( nullvec, 1.0, sbv_t, 0.01 );
	        break;
	        case( 'j' ):				/* move left */
	  	  VECSET( sbv_t,-1.0, 0.0, 0.0 );
		  spcbal_do( nullvec, 1.0, sbv_t, 0.01 );
	        break;
	        case( 'k' ):				/* move right */
	  	  VECSET( sbv_t,+1.0, 0.0, 0.0 );
		  spcbal_do( nullvec, 1.0, sbv_t, 0.01 );
	        break;
  
	        case( 'o' ):				/* +z axis */
	  	  VECSET( sbv_t, 0.0, 1.0, 0.0 );
		  spcbal_do( nullvec, 1.0, sbv_t, 0.01 );
	        break;
	        case( 'l' ):				/* -z axis */
	  	  VECSET( sbv_t, 0.0,-1.0, 0.0 );
		  spcbal_do( nullvec, 1.0, sbv_t, 0.01 );
	        break;
		case( 'c' ):				/* toggle between object/eye mode */
		  sbx_k4( 0, 1, 0 );
		break;
	      }
	    break;
  
	  }
}
/*-----------------------*--------------------------------------------------------------------------*/

int key_mouse_events2( short devid, short val )		/* SGI keyboard decode during spline run */
{
	switch( devid ) {
	  case( 'Q' ):					/* exit program */
	    exit(0);
	  break;
	  default:
	  return(0);
	}
}
/*-----------------------*--------------------------------------------------------------------------*/
#endif
