
/* $Header: gl_int.h,v 1.32 93/10/12 12:57:55 apian Exp $ */


/* general graphics stuff */

typedef struct {			/* camera parameters in SGI coordinates */
	float	pos[3];			/* position */
	float	dreh, kipp, tilt;	/* y, x, z  rotation */
	} cam_para;

#define	HAS_SPACEBALL	0x01		/* spaceball attached */
#define	HAS_ACCU	0x02		/* SGI accu bitplanes */
#define	HAS_RGB		0x04		/* 2x RGB color bitplanes */
#define	HAS_DOUBLE	0x08		/* doublebuffer support */
#define	HAS_Z		0x10		/* has zbuffer */
#define	HAS_OVERLAY	0x20		/* has overlay bitplanes */

	/* opmodes: high byte: last opcode, low byte: new opcode */
#define OM_NORMALVIEW	0x01	/* normal, default operation mode */
#define OM_IPICK	0x02	/* instance pick mode */
#define	OM_CP		0x03	/* camera path modify mode */
#define OM_OMASK	0xf0	/* old op mask */

#define PICK_TYPE_INSTANCE      1
#define PICK_TYPE_CAMKNOT       2
#define PICK_TYPE_CAMINT	3

#define	CAMKNOT_FACTOR		80.0		/* worldsize devided by this = size */

typedef struct {
	int	draw_polygons;			/* what to draw */
	int	draw_meshes;
	int	draw_instances;
	int	draw_segments;
	int	draw_ambient_flag;
	int	draw_campol;
	int	draw_monitor;
	int	draw_display;
	int	draw_help;
	int	overlay_on;			/* overlay currently on */
	int	backface_flag;
	int	max_depth;
	int	octree_loaded_flag;
	int	opmode;
	int 	hastable;		/* some hardware features */
	short	ncolors_cmode;			/* colors available in dbl buffer cmode */
	int	picked_type;			/* what sort of thing was picked */
	struct {				/* pointer to that thing */
	  rshow_instance *inst;
	  cam_para *cp;
	} picked;
	cam_para old_cp;			/* old campara, last settings before current click */
	float	front_clip, back_clip;		/* changable hardware stuff */
	float	front_clip_min, clip_step;	/* minimum front clip distance and steps to change */
	long	height, width;
	float	fov, aspect;			/* field-of-view and width/height aspect ratio */
	float	world_size;
	HUBA_matrix	my_matrix;		/* matrix for current viewpoint */
	HUBA_matrix	reset_matrix;		/* matrix for "R" or spaceball-reset */
	HUBA_matrix	vf_matrix;		/* viewfile or RADIANCE default matrix */
	HUBA_matrix	proj_matrix;		/* only needed by VOGL */
	cam_para	current_cam;		/* current camera parameters */
	float	lps;				/* loops per second */
	} radi_gl_attris;


/* defined in gl_int.c and gl_mat.c or whatever */

	void prepare_display();
	void reset_object_trafo();
	void setup_object_trafo( HUBA_matrix );
	void pushmult_object_trafo( HUBA_matrix );
	void set_world_scale( float *, float );
	void set_perspective();
	
	void swap_gl_to_rad( float *);
	void get_rview_position( float *, float *, float *, float *, float *);
	void camvec_to_rotangles( float *, float *, float *, float *, float * );
	void build_mat( float *, float *, float *);
	void set_rview_position( float *, float *, float *);
	void set_cam_object_position( float *, float *, float *);
	void print_instance_trafo( rshow_instance *);
	void write_view_paras( FILE *, float *, float *, float *, float, float );
	int write_view_file( char * );
	
	void init_graphics_hardware( char * );
	void attri_init( int );
	void setup_object_trafo( HUBA_matrix );
	void prepare_polygons();
	void display_polygons( int, float*, rshow_polygons* );
	void display_4polygons( int, float*, rshow_4polygons* );
	void prepare_meshes();
	void display_meshes( float*, rshow_meshes* );
	void set_rview_position( float *, float *, float * );
	void update_view_matrix( cam_para * );
	void pick_start_instance( rshow_instance *);
	void pick_end_instance( );
	int pick_stuff();

	int key_mouse_events2( short, short );
	int key_mouse_events( short, short );

	unsigned long *read_rad_file( char *, int *, int *, int);
