%{
#ifdef I_STRING
#include <string.h>
#else
#include <strings.h>
#endif

#define Float   double
#include "y.tab.h"

#include <stdio.h>
#include <stdlib.h>
extern char *strsave();
%}
alpha	[a-zA-Z]
special	[\.\_-]
digit	[0-9]
exp	[Ee][-+]?{digit}+
%p 9400
%e 1500
%n 600
%%
[ \t\n]			;
"/*"			skipcomments();
"#"			skipcomments2();

rview			return tPROG;
rpict			return tPROG;
pinterp			return tPROG;
rshow			return tPROG;
-vtv			return tVIEWTYPE;
-vtl			return tVIEWTYPE;
-vta			return tVIEWTYPE;
-vth			return tVIEWTYPE;
-vp			return tVIEWPOINT;
-vd			return tVIEWDIRECTION;
-vu			return tVIEWUP;
-vh			return tVIEWHOR;
-vv			return tVIEWVERT;
-vs			return tVIEWSHIFT;
-vl			return tVIEWLIFT;
-knot_a			return tKNOT_A;
-knot_frames		return tKNOT_FRAMES;

{digit}+ |
{digit}+"."{digit}*({exp})? |
{digit}*"."{digit}+({exp})? |
{digit}+{exp}		{yylval.d = atof(yytext); return tFLOAT;}
.			return yytext[0];

%%
yywrap() {return 1;}
/*
 * Skip over comments.
 */
skipcomments()
{
	char c;

	while (1) {
		while (input() != '*')
			;
		if ((c = input()) == '/')
			return;
		unput(c);
	}
}
/*
 * Skip over comments.
 */
skipcomments2()
{
	char c;

	while (1) {
	  if ((c = input()) == '\n') return;
	}
}


