%{
#include <stdio.h>
#include "rshow.h"
#include "instances.h"
#include "gl_int.h"
#include "campol.h"
#define Float	double

/* $Header: /home/hobbes/guest/apian/radiance/RCS/yacc.y,v 1.4 92/12/11 00:39:02 apian Exp Locker: apian $ */

char yyfilename[BUFSIZ];			/* Input filename */

extern FILE *yyin;				/* input file pointer */
extern int yylineno;				/* Current line # in file */

float vp[3], vd[3], vu[3], vv, vh;
cam_para cp;
int	knot_frames=20;
float	knot_a=0.5;

%}
%union {
	char *c;
	int i;
	Float d;
}
%token <d> tFLOAT 
%token <i> tPROG tVIEWTYPE tVIEWPOINT tVIEWDIRECTION tVIEWUP tVIEWHOR tVIEWVERT tVIEWSHIFT tVIEWLIFT
%token <i> tKNOT_FRAMES tKNOT_A
%type <d> Float

%left '+' '-'
%left '*' '/' '%'
%left UMINUS
%right '^'
%%
Items		: /* empty */
		| Items Item
		;
Item		: tPROG Options
		{
/*
			printf(" (%g %g %g) (%g %g %g) (%g %g %g)\n",
				vp[0],vp[1],vp[2],
				vd[0],vd[1],vd[2],
				vu[0],vu[1],vu[2] );
			printf(" frames=%d a=%g\n",knot_frames, knot_a);
*/
			cp.pos[0]= vp[0];
			cp.pos[1]= vp[1];
			cp.pos[2]= vp[2];
			camvec_to_rotangles( vd, vu, &(cp.dreh), &(cp.kipp), &(cp.tilt) );
	 		cpk_enter( &cp, knot_frames, knot_a, NULL );
		}
		;
Options		: /* empty */
		| Options Option
		;
Option		: tVIEWTYPE | Point | Dir | Up | Angles | Shift | Knot
		;
Point		: tVIEWPOINT Float Float Float
		{
			vp[0]= $2;		/* radiance -> sgi gl coordinates */
			vp[1]= $4;
			vp[2]= -$3;
		}
		;
Dir		: tVIEWDIRECTION Float Float Float
		{
			vd[0]= $2;
			vd[1]= $4;
			vd[2]= -$3;
		}
		;
Up		: tVIEWUP Float Float Float
		{
			vu[0]= $2;
			vu[1]= $4;
			vu[2]= -$3;
		}
Angles		: tVIEWHOR Float
		{
			vh= $2;
		}
		| tVIEWVERT Float
		{
			vv= $2;
		}
		;
Shift		: tVIEWSHIFT Float | tVIEWLIFT Float
		;
Knot		: tKNOT_A Float
		{
	 		knot_a= $2;
		}
		| tKNOT_FRAMES  Float
		{
			knot_frames= $2;
		}
		;
Float		: tFLOAT
		| '-' tFLOAT
		{ $$ = -$2; }
		| '+' tFLOAT
		{ $$ = $2; }
		;
%%
/*
 * Issue error message containing filename and line number, and exit.
 */
/*VARARGS1*/
yyerror(s, pat1, pat2)
char *s, *pat1, *pat2;
{
	fprintf(stderr,"Error: %s: line %d: ", yyfilename, yylineno);
	fprintf(stderr, s, pat1, pat2);
	if (*s && s[strlen(s) -1] != '\n')
		/* YACC doesn't put newlines on error messages. */
		fprintf(stderr,"\n");	
	fflush(stderr);
}

